// Copyright (c) 2008, NTT DATA Corporation.
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//      http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

using System;
using System.Collections.Generic;
using System.Configuration;
using System.Text;
using TERASOLUNA.Fw.Common.Logging;

namespace TERASOLUNA.Fw.Common.Configuration.BLogic
{
    /// <summary>
    /// ビジネスロジック設定ファイルから <see cref="BLogicConfiguration"/> 設定情報を取得します。
    /// </summary>
    public abstract class BLogicConfiguration
    {
        /// <summary>
        /// <see cref="ILog"/> 実装クラスのインスタンスです。
        /// </summary>
        /// <remarks>
        /// ログ出力に利用します。
        /// </remarks>
        private static ILog _log = LogFactory.GetLogger(typeof(BLogicConfiguration));

        /// <summary>
        /// BLogic のタイプ名を取得します。
        /// </summary>
        /// <param name="name">取得する <see cref="Common.BLogic.IBLogic"/> の識別子。</param>
        /// <returns>存在する場合は、<paramref name="name"/> 引数の値に対応する <see cref="Common.BLogic.IBLogic"/> のタイプ名。それ以外の場合は null 参照です。</returns>
        /// <remarks>
        /// ビジネスロジック設定ファイルから、<paramref name="name"/> の値に対応する type 属性の値を取得します。
        /// </remarks>
        /// <exception cref="ArgumentNullException">
        /// <paramref name="name"/> が null 参照です。
        /// </exception>
        /// <exception cref="ArgumentException">
        /// <paramref name="name"/> が空の文字列です。
        /// </exception>
        /// <exception cref="ConfigurationErrorsException">
        /// <item>
        /// <see cref="BLogicConfigurationSection"/> を取得できません。
        /// </item>
        /// </exception>
        public static string GetBLogicTypeName(string name)
        {
            if (name == null)
            {
                ArgumentNullException exception = new ArgumentNullException("name");
                if (_log.IsErrorEnabled)
                {
                    _log.Error(string.Format(Properties.Resources.E_NULL_ARGUMENT, "name"), exception);
                }
                throw exception;
            }
            if (name.Length == 0)
            {
                string message = string.Format(Properties.Resources.E_EMPTY_STRING, "name");
                ArgumentException exception = new ArgumentException(message);
                if (_log.IsErrorEnabled)
                {
                    _log.Error(message, exception);
                }
                throw exception;
            }

            BLogicConfigurationSection  blogicConfigSection = TerasolunaConfiguration.BLogicConfigSection;
            BLogicElement element;
            if (blogicConfigSection == null)
            {
                return null;
            }
            else
            {
                element = blogicConfigSection.BLogicCollection[name];
            }
            
            // nameに対応する設定が無い場合はnullを返却する
            if (element == null)
            {
                if (_log.IsTraceEnabled)
                {
                    _log.Trace(string.Format(
                        Properties.Resources.T_BLOGIC_CONFIGURATION_NOT_LOAD_PARAMETER, name));
                }

                return null;
            }

            if (_log.IsTraceEnabled)
            {
                _log.Trace(string.Format(
                    Properties.Resources.T_BLOGIC_CONFIGURATION_LOAD_PARAMETER, name, element.Type));
            }

            return element.Type;
        }

        /// <summary>
        /// <see cref="Common.BLogic.IBLogic"/> が利用する DB 接続の識別子を取得します。
        /// </summary>
        /// <param name="name">取得する <see cref="Common.BLogic.IBLogic"/> の識別子。</param>
        /// <returns>存在する場合は、<paramref name="name"/> 引数の値に対応する <see cref="Common.BLogic.IBLogic"/> の DB 接続名のリスト。
        /// それ以外の場合は空の <see cref="List{String}"/> を返却します。</returns>
        /// <remarks>
        /// ビジネスロジック設定ファイルから、<paramref name="name"/> の値に対応する dbInfo ノードの値を取得します。
        /// </remarks>
        /// <exception cref="System.ArgumentNullException">
        /// <paramref name="name"/> が null 参照です。
        /// </exception>
        /// <exception cref="System.ArgumentException">
        /// <paramref name="name"/> が空の文字列です。
        /// </exception>
        /// <exception cref="ConfigurationErrorsException">
        /// <item>
        /// <see cref="BLogicConfigurationSection"/> を取得できません。
        /// </item>
        /// </exception>
        public static List<string> GetDbNames(string name)
        {
            if (name == null)
            {
                ArgumentNullException exception = new ArgumentNullException("name");
                if (_log.IsErrorEnabled)
                {
                    _log.Error(string.Format(Properties.Resources.E_NULL_ARGUMENT, "name"), exception);
                }
                throw exception;
            }
            if (name.Length == 0)
            {
                string message = string.Format(Properties.Resources.E_EMPTY_STRING, "name");
                ArgumentException exception = new ArgumentException(message);
                if (_log.IsErrorEnabled)
                {
                    _log.Error(message, exception);
                }
                throw exception;
            }

            List<string> dbNames = new List<string>();

            BLogicConfigurationSection blogicConfigSection = TerasolunaConfiguration.BLogicConfigSection;
            BLogicDbInfoCollection dbInfos;
            if (blogicConfigSection != null)
            {
                if (blogicConfigSection.BLogicCollection[name] != null)
                {
                    dbInfos = blogicConfigSection.BLogicCollection[name].DbInfos;
                    foreach (BLogicDbInfoElement dbInfo in dbInfos)
                    {
                        dbNames.Add(dbInfo.Name);
                    }
                }
            }

            if (_log.IsTraceEnabled)
            {
                if (dbNames.Count == 0)
                {
                    _log.Trace(string.Format(Properties.Resources.T_NO_DBINFO_COLLECTION, name));
                }
                else
                {
                    StringBuilder builder = new StringBuilder(
                        string.Format(Properties.Resources.T_DBINFO_COLLECTION, name));
                    foreach (string dbName in dbNames)
                    {
                        builder.AppendLine(dbName);
                    }
                    _log.Trace(builder.ToString().Trim());
                }
            }

            return dbNames;
        }
    }
}
